#$Id: 3PAR.pm,v 1.1 2012/09/19 05:54:50 vkaul Exp $
#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

package VRTS::Enclosure::VDID::3PAR;
use strict;
use Carp;
require Exporter;


sub new 
{
    my $class = shift;
    my $self = {};

    bless ($self, $class);
    return $self;
}

sub initialize
{
    my $top = shift;

    my $module = new VRTS::Enclosure::VDID::3PAR;
    return $module;

}

sub get_enclosure_vdid
{
    my $self = shift;
    my $make = shift;
    my $product = shift;
    my $sys_id = shift;

    # Convert sys_id to all caps.
    $sys_id =~ tr/a-z/A-Z/;

    if (length($sys_id) == 3)
    {
        return $make."_".$product."_0".$sys_id;
    }

    return $make."_".$product."_".$sys_id;
}

sub get_disk_vdid
{
    my $self = shift;
    return undef;
}

sub _get_pdev_vdid
{
    return undef;
}

1;
