#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

package VRTS::Enclosure::VDID::SVC;
use strict;

sub new 
{
    my $class = shift;
    my $self = {};

    bless ($self, $class);
    return $self;
}

sub initialize
{
    my $class = shift;

    my $module = new VRTS::Enclosure::VDID::SVC;
    return $module;
}

sub get_enclosure_vdid
{
    my $self = shift;
    my $vendor = shift;
    my $model = shift;
    my $id = shift;

    return $vendor."_".$model."_".$id if ($vendor && $model && $id);
    return undef;
}

sub get_disk_vdid
{
    my $self = shift;
    my $vendor = shift;
    my $model = shift;
    my $cabsno = shift;
    my $serial = shift;
    my $is_pdev = shift;
    my $pdev_name = shift;

    if (not defined $is_pdev or $is_pdev == 1)
    {
        return _get_pdev_vdid ($vendor, $cabsno, $pdev_name);
    } 
    return $vendor."_".$cabsno."_".$serial;
}

sub _get_pdev_vdid
{
    my $vendor = shift;
    my $cabsno = shift;
    my $pdev_name = shift;

    return $vendor."_".$cabsno."_".$pdev_name;
}

1;
