#$Id: Symmetrix.pm,v 1.1 2012/09/19 05:54:50 vkaul Exp $
#$copyright$

package VRTS::Enclosure::VDID::Symmetrix;
use strict;
use Carp;
require Exporter;


sub new 
{
    my $class = shift;
    my $self = {};

    bless ($self, $class);
    return $self;
}

sub initialize
{
    my $top = shift;

    my $module = new VRTS::Enclosure::VDID::Symmetrix;
    return $module;

}

sub get_enclosure_vdid
{
    my $self = shift;
    my $vendor = shift;
    my $product = shift;
    my $cabsno = shift;

    return "$vendor"."$cabsno" if ($vendor and $cabsno);
    return undef;
}

sub get_disk_vdid
{
    my $self = shift;
    my $vendor = shift;
    my $product = shift;
    my $cabsno = shift;
    my $serial = shift;
    my $is_pdev = shift;
    my $pdev_name = shift;

    if (not defined $is_pdev or $is_pdev == 1)
    {
        return _get_pdev_vdid($vendor, $product, $cabsno, $serial, $pdev_name);
    } 

    # We want to generate an ldev vdid.
    return "$vendor"."$cabsno"."$serial";
}

sub _get_pdev_vdid
{
    my $vendor = shift;
    my $product = shift;
    my $cabsno = shift;
    my $serial = shift;
    my $pdev_name = shift;

    return "$vendor"."$cabsno"."$pdev_name";
}

1;
