#$Id: Catalog.pm,v 1.1 2012/09/25 22:32:59 joe Exp $
#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

package VRTS::Enclosure::SIPlugin::Catalog;
require Exporter;
use strict;
use vars qw($VERSION @ISA @EXPORT);
$VERSION = '5.00';
@ISA = qw(Exporter);
@EXPORT = qw[VENDOR_COMP_NOT_FOUND NO_ARRAYS_DISCOVERED PROBE_INTERNAL_ERROR 
             INVALID_FIELD_VALUE NO_OBJECTS_DISCOVERED MH_NOT_REACHABLE 
             FAILED_TO_OPEN_DATA_FILE DATA_FILE_NOT_FOUND
            ];

use constant VENDOR_COMP_NOT_FOUND => 1001;
use constant NO_ARRAYS_DISCOVERED => 1004;
use constant MH_NOT_REACHABLE => 1005;
use constant PROBE_INTERNAL_ERROR => 1010;


use constant INVALID_FIELD_VALUE => 2000;
use constant NO_OBJECTS_DISCOVERED => 2001;
use constant FAILED_TO_OPEN_DATA_FILE => 2002;
use constant DATA_FILE_NOT_FOUND => 2003;
use constant DSC_CMD_FAILED => 2004;
use constant FAILED_TO_EXEC_DSC_CMD => 2005;
use constant DSC_SCRIPT_NOT_FOUND => 2006;
use constant DSC_SCRIPT_SETUP_FAILED => 2007;
1;
