#!/opt/VRTSsfmh/bin/perl
#$Id: unsetup.pl,v 1.1 2012/09/25 22:32:59 joe Exp $
#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ($^O !~ /Win32/i);}

use strict;
use VRTS::Paths;
use File::Spec;
use VRTS::Util;
use VRTS::Ini;

my $addon_dir = $ENV{Store};
my $installdir = VRTS::Paths::get_path ("InstallDir");
my $perl = File::Spec->catfile ($installdir, "bin", "perl");
my $setup =  File::Spec->catfile($addon_dir, "setup.pl");

my $cmd = VRTS::Util::make_command($perl, $setup, "--operation", "uninstall");
print "calling command $cmd\n";
my $out = `$cmd 2>&1`;
my $ret = $?;
if ($ret == 1)
{
    print STDERR "Failed to Uninstall the plugin: $out\n";
}
else
{
    print "Successfully uninstalled the plugin\n";
}
exit($ret);
