#!/opt/VRTSsfmh/bin/perl

#$Id: sisdk_ui_downloadFile.pl,v 1.1 2012/09/25 22:33:00 joe Exp $
#$Copyrights: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ( $^O !~ /Win32/i ) }

use lib;
use strict;
use CGI;
use File::Path;
use JSON;
use VRTS::SISdk::Util;
require VRTS::Paths;
use File::Path;
use File::Spec;
use IO::Handle;
my $installdir  = VRTS::Paths::get_path ("InstallDir");
my $appdir =  VRTS::Paths::get_path ("AppDir");
my $log_dir = File::Spec->catdir($appdir,"logs");

main();

sub main() {
   my @fileholder;  
   my $log = new VRTS::Logger(Module => 'sisdk', Logdir => $log_dir, Level => 'debug', Logfile => 'sisdkui.log', UmiString => '');

   my $query = new CGI();
   my $action = $query->param("action");
   
   if ("deleteTempFile" eq $action  ) {
       deleteTempFiles($query);
   }else{
       my $file = $query->param("path");
       
       if ($file eq '') {  
          print "Content-type: text/html\n\n";  
          print "You must specify a file to download.";   
       } else {  
           open(my $DLFILE, '<', "$file") or Error('open', 'file');
           my $baseFileName = VRTS::SISdk::Util::GetBasename($file);
           print $query->header(-type   => 'application/x-download',
                            -attachment => $baseFileName,
                            -Content_length  => -s "$file",
           );         
           binmode $DLFILE;
           print while <$DLFILE>;
           close ($DLFILE) || Error ('close', 'file');
           undef ($DLFILE);
       }
       deleteTempFiles($query);
       print "Location: ../htdocs/sisdk.html\n\n";
    }
} 

sub deleteTempFile{
   my $fileName = shift;
   my $files_deleted = File::Path::rmtree($fileName);
   VRTS::Logger::log('debug', "$fileName is deleted $files_deleted" );
}
sub deleteTempFiles{
   my $query = shift;
   my $cmdScriptDirectory = $query->cookie("commandScript");
   my $conf_file= $query->cookie("conf_file");    
   my $sisdkAddOnTempDir = $query->cookie("sisdkAddOnTempDir");
   if (-f $cmdScriptDirectory) {   
      deleteTempFile($cmdScriptDirectory);
   }
   if (-f $conf_file) {   
      deleteTempFile($conf_file);
   }
   if (-f $sisdkAddOnTempDir) {   
      deleteTempFile($sisdkAddOnTempDir);
   }
   my $addOnSfaFile =  $query->param("addOnSfaFile");
   if (-f $addOnSfaFile) {   
       my $dirName = File::Basename::dirname ($addOnSfaFile);
       deleteTempFile($dirName);
   }
}

sub Error {  
     print "Content-type: text/html\n\n";  
     print "The server can't $_[0] the $_[1]: $! \n";  
     exit;  
}  
