#!/opt/VRTSsfmh/bin/perl
#$Id: sisdk_ui_getUploadedCmdScript.pl,v 1.1 2012/09/25 22:33:00 joe Exp $
#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $
BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ( $^O !~ /Win32/i ) }

use lib;
use strict;
use CGI;
use JSON;
require Net::DNS::Resolver;
require VRTS::ProgressBar;
require VRTS::Ini;
require VRTS::Paths;
require VRTS::Util;
use File::Path;
use File::Spec;
use VRTS::I18N;
require VRTS::SFMHCAT;
use VRTS::CGILOCALE;
require VRTS::CMD;
use threads;
use threads::shared;
use File::Copy;
use File::Temp;
use VRTS::Util;
use Archive::Tar;
use IO::Handle;
my $appdir = VRTS::Paths::get_path("AppDir");
my $log_dir = File::Spec->catdir($appdir,"logs");

main();

sub main{
    my $query = new CGI();
    my $log = new VRTS::Logger(Module => 'sisdk', Logdir => $log_dir, Level => 'debug', Logfile => 'sisdkui.log', UmiString => '');
    print "Content-type:text/html\r\n\r\n";
    my $temp_store = $query->cookie("commandScript");	
    VRTS::Logger::log('debug',"command script temp_store $temp_store:$@");
    my $iDiscoveryFileName = $query->cookie("iDiscoveryFileName");	

    my $displayRow = "";
    my $fileCount = 0;   
    my $setDiscoveryFileName ='<SCRIPT id="setDiscoveryFileName" type="text/javascript">';    
  
    if (-d $temp_store) {
        chdir $temp_store;
        opendir (D, $temp_store);
        my @files = <*>;
        closedir (D);
        $fileCount = $#files + 1; 
        my $counter = 0;
        foreach my $file (@files) {    
          if ($file ne "." && $file ne "..")
          {
             my $Filename = $file;
             my $fileType ="Additional Script";
             if ($Filename eq $iDiscoveryFileName) {
                $fileType = "Discovery Script";
                $setDiscoveryFileName = join "", $setDiscoveryFileName, 'setiDiscoveryFileName("', $Filename, '")';
             }
             if ("Readme.html" eq $Filename) {
               $fileType = "Readme";
             }
             if ("check_env.pl" eq $Filename) {
               $fileType = "check env ";
             }  

             $displayRow = join "", $displayRow, commandScriptTableRow($Filename, $fileType, $counter);
             $counter = $counter + 1;
          }
        }
    }
    print join "", $setDiscoveryFileName, "</script>",  commandScriptTableHeader();
    print commandScriptTableNoRow($fileCount);
    print $displayRow;
}


sub commandScriptTableHeader(){
   my $header ="";
   $header = join "", $header,	"<tbody>";
   $header = join "", $header, '<tr class="odd_row"><td width="50%"></td><td width="15%"></td><td width="10%"></td></tr>';
   return $header;		
}

sub commandScriptTableNoRow(){
   my $fileCount =  $_[0];
   my $norow ="";
   my $display = "";
   if ($fileCount > 0) {
     $display = "none";
   }
   $norow = join "", $norow, '<tr id="fileRow_0" class="even_row" style="display:', $display  , ';"><td colspan="3" class="grid_td" style="text-align: center">No rows to display</td></tr>';					
   return $norow; 
}
sub commandScriptTableRow(){
   my ($fileName, $fileType, $count) = @_;
   my $row ="";
   $row = join "", $row, '<tr id="rowCount_', $count, '">';
   $row = join "", $row, '<td class="padded"><span id="ifile_', $count, '">', $fileName, '</span></td><td><span id="iFiltType_', $count, '">', $fileType, '</span></td>';	     
   $row = join "", $row, '<td><div><a href="javascript:void(0);" onclick="deleteFileTableRow(\'rowCount_', $count, '\', \'', $fileName ,'\')" id="HrDelRow_', $count, '">';
   $row = join "", $row, '<img border="0" id="ImDeleteRow_', $count, '" alt="Delete row" src="images/remove_file.gif" title="Delete row"></a>';
   $row = join "", $row, '</div>';
   $row = join "", $row, '</td>';
   $row = join "", $row, '</tr>';
}
sub commandScriptTableEnd(){
   my $end =  "</tbody>";
   return $end;
}