#!/opt/VRTSsfmh/bin/perl
#$Id: sisdk_ui_handleCapability.pl,v 1.1 2012/09/25 22:33:00 joe Exp $
#$Copyright: Copyright (c) 2014 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ( $^O !~ /Win32/i ) }

use lib;
use strict;
use CGI;
use JSON;
use File::Spec;
use VRTS::Paths;
use File::Spec;
use File::Path;
use File::Copy;
use File::Temp;
use VRTS::Util;
use POSIX;

my $appdir = VRTS::Paths::get_path("AppDir");
my $log_dir = File::Spec->catdir($appdir,"logs");
my $installdir  = VRTS::Paths::get_path ("InstallDir");

main();

sub main{    
    my $query = new CGI();
    my $log = new VRTS::Logger(Module => 'sisdk', Logdir => $log_dir, Level => 'debug', Logfile => 'sisdkui.log', UmiString => '');

    if ($query->param("act") eq "saveCapability") {
       saveCapability($query);
       print "Location: ../htdocs/sisdk_deviceIdentifer.html\n\n";
    }elsif ($query->param("act") eq "init") {
       initializeCookieStorage($query);
       print "Location: ../htdocs/sisdk_uploadScript.html\n\n";	
    }elsif ($query->param("act") eq "saveCliParam") {
       saveCliParameters($query);
       print "Location: ../htdocs/sisdk_capability.html\n\n";	
    }elsif ($query->param("act") eq "initForEdit") {
       initializeCookieStorage($query);
       print "Location: ../htdocs/sisdk_uploadAddon.html\n\n";
    }elsif ($query->param("act") eq "initForTest") {
       initializeCookieStorage($query);
       print "Location: ../htdocs/sisdk_uploadAddonToTest.html\n\n";
    }elsif ($query->param("act") eq "saveDeviceIdentifer") {
       saveDeviceIdentifer($query);
       print "Location: ../htdocs/sisdk_confirmation.html\n\n";
    }
}

sub saveCapability(){
    my $query = $_[0];
    #----------set cookie--------------
    #my $iVendor = $query->param("iVendor");
    #my $iVendorCookie= $query->cookie(-name=>"iVendor", -value=>"$iVendor");	
    #print "Set-Cookie:$iVendorCookie;\n"; 

    #---Discover Physical Disks
    my $chDiscoveryPhysicalDisk = $query->param("chDiscoveryPhysicalDisk");
    my $chDiscoveryPhysicalDiskCookie = $query->cookie(-name=>"chDiscoveryPhysicalDisk", -value=>"$chDiscoveryPhysicalDisk");
    print "Set-Cookie:$chDiscoveryPhysicalDiskCookie\n"; 
    
    my $iPhysicalDiskTerm = $query->param("iPhysicalDiskTerm");
    if($chDiscoveryPhysicalDisk ne "DiscoveryPhysicalDisk")
    {
        $iPhysicalDiskTerm = "";
    }
    my $iPhysicalDiskTermCookie = $query->cookie(-name=>"iPhysicalDiskTerm", -value=>"$iPhysicalDiskTerm");
    print "Set-Cookie:$iPhysicalDiskTermCookie\n"; 

    #---Discover Physical Groups 
    my $chDiscoveryPhysicalGroup  = $query->param("chDiscoveryPhysicalGroup");
    my $chDiscoveryPhysicalGroupCookie= $query->cookie(-name=>"chDiscoveryPhysicalGroup", -value=>"$chDiscoveryPhysicalGroup");	
    print "Set-Cookie:$chDiscoveryPhysicalGroupCookie;\n"; 
  
    my $iPhysicalGroupTerm = $query->param("iPhysicalGroupTerm");
    if($chDiscoveryPhysicalGroup ne "chDiscoveryPhysicalGroup"){
       $iPhysicalGroupTerm = "";        
    }
    my $iPhysicalGroupTermCookie= $query->cookie(-name=>"iPhysicalGroupTerm", -value=>"$iPhysicalGroupTerm");
    print "Set-Cookie:$iPhysicalGroupTermCookie;\n"; 
    
    #---Discover Array Ports
    my $chDiscoverArrayPort = $query->param("chDiscoverArrayPort");
    my $chDiscoverArrayPortCookie= $query->cookie(-name=>"chDiscoverArrayPort", -value=>"$chDiscoverArrayPort");	
    print "Set-Cookie:$chDiscoverArrayPortCookie;\n"; 
    
    #---Discover Adapters
    my $chDiscoverAdapter = $query->param("chDiscoverAdapter");
    my $chDiscoverAdapterCookie= $query->cookie(-name=>"chDiscoverAdapter", -value=>"$chDiscoverAdapter");	
    print "Set-Cookie:$chDiscoverAdapterCookie;\n"; 

    #---Discover raid group
    my $chDiscoverRaidGroup = $query->param("chDiscoverRaidGroup");
    my $chDiscoverRaidGroupCookie= $query->cookie(-name=>"chDiscoverRaidGroup", -value=>"$chDiscoverRaidGroup");	
    print "Set-Cookie:$chDiscoverRaidGroupCookie;\n"; 

    my $iRaidGroupTerm = $query->param("iRaidGroupTerm");
    my $iRaidGroupTermCookie= $query->cookie(-name=>"iRaidGroupTerm", -value=>"$iRaidGroupTerm");	
    print "Set-Cookie:$iRaidGroupTermCookie;\n"; 

    my $chRaidGroupPhysicalMapping = $query->param("chRaidGroupPhysicalMapping");
    my $chRaidGroupPhysicalMappingCookie= $query->cookie(-name=>"chRaidGroupPhysicalMapping", -value=>"$chRaidGroupPhysicalMapping");	
    print "Set-Cookie:$chRaidGroupPhysicalMappingCookie;\n"; 

    #--Discover Logical Disks
    my $chDiscoverLogicalDisk = $query->param("chDiscoverLogicalDisk");
    my $chDiscoverLogicalDiskCookie= $query->cookie(-name=>"chDiscoverLogicalDisk", -value=>"$chDiscoverLogicalDisk");	
    print "Set-Cookie:$chDiscoverLogicalDiskCookie;\n"; 

    my $iLogicalDiskTerm  = $query->param("iLogicalDiskTerm");
    if($chDiscoverLogicalDisk  ne "DiscoverLogicalDevices"){
        $iLogicalDiskTerm = "";
        my $chMetaLogicalDiskCookie= $query->cookie(-name=>"chMetaLogicalDisk", -value=>"");	
        print "Set-Cookie:$chMetaLogicalDiskCookie;\n";

        my $chDiscoverLogHostMappingCookie= $query->cookie(-name=>"chDiscoverLogHostMapping", -value=>"");	
        print "Set-Cookie:$chDiscoverLogHostMappingCookie;\n"; 

        my $chDiscoverLogPhyMappingCookie= $query->cookie(-name=>"chDiscoverLogPhyMapping", -value=>"");	
        print "Set-Cookie:$chDiscoverLogPhyMappingCookie;\n"; 
   }else{
        my $chMetaLogicalDisk  = $query->param("chMetaLogicalDisk");
        my $chMetaLogicalDiskCookie= $query->cookie(-name=>"chMetaLogicalDisk", -value=>"$chMetaLogicalDisk");	
        print "Set-Cookie:$chMetaLogicalDiskCookie;\n";

        my $chDiscoverLogHostMapping  = $query->param("chDiscoverLogHostMapping");
        my $chDiscoverLogHostMappingCookie= $query->cookie(-name=>"chDiscoverLogHostMapping", -value=>"$chDiscoverLogHostMapping");	
        print "Set-Cookie:$chDiscoverLogHostMappingCookie;\n"; 

        my $chDiscoverLogPhyMapping  = $query->param("chDiscoverLogPhyMapping");
        my $chDiscoverLogPhyMappingCookie= $query->cookie(-name=>"chDiscoverLogPhyMapping", -value=>"$chDiscoverLogPhyMapping");	
        print "Set-Cookie:$chDiscoverLogPhyMappingCookie;\n"; 
    }
    my $iLogicalDiskTermCookie= $query->cookie(-name=>"iLogicalDiskTerm", -value=>"$iLogicalDiskTerm");	
    print "Set-Cookie:$iLogicalDiskTermCookie;\n"; 
    
    if ($chDiscoverRaidGroup eq "DiscoverRaidGroup") {    
        my $chRaidGroupLogicalDiskMapping  = $query->param("chRaidGroupLogicalDiskMapping");
        my $chRaidGroupLogicalDiskMappingCookie= $query->cookie(-name=>"chRaidGroupLogicalDiskMapping", -value=>"$chRaidGroupLogicalDiskMapping");	
        print "Set-Cookie:$chRaidGroupLogicalDiskMappingCookie;\n"; 
    }
  
    my $iTermMetaLogicalDisk  = $query->param("iTermMetaLogicalDisk");
    my $iTermMetaLogicalDiskCookie= $query->cookie(-name=>"iTermMetaLogicalDisk", -value=>"$iTermMetaLogicalDisk");	
    print "Set-Cookie:$iTermMetaLogicalDiskCookie;\n"; 
    
    #--	Discover Replications
    
    my $chDiscoverReplications  = $query->param("chDiscoverReplications");
    my $chDiscoverReplicationsCookie= $query->cookie(-name=>"chDiscoverReplications", -value=>"$chDiscoverReplications");	
    print "Set-Cookie:$chDiscoverReplicationsCookie;\n"; 

#    my $remoteReplicationRadio  = $query->param("remoteReplicationRadio");
#    my $remoteReplicationRadioCookie= $query->cookie(-name=>"remoteReplicationRadio", -value=>"$remoteReplicationRadio");
#    print "Set-Cookie:$remoteReplicationRadioCookie;\n"; 

    my $chDiscoverRemoteReplication  = $query->param("chDiscoverRemoteReplication");
    my $chDiscoverRemoteReplicationCookie= $query->cookie(-name=>"chDiscoverRemoteReplication", -value=>"$chDiscoverRemoteReplication");
    print "Set-Cookie:$chDiscoverRemoteReplicationCookie;\n"; 

    #-- Discover Logical Groups
    my $chLogicalGroup  = $query->param("chLogicalGroup");
    my $chLogicalGroupCookie= $query->cookie(-name=>"chLogicalGroup", -value=>"$chLogicalGroup");	
    print "Set-Cookie:$chLogicalGroupCookie;\n"; 
    
    my $iLogicalGroupTerm  = $query->param("iLogicalGroupTerm");
    if($chLogicalGroup ne "DiscoverLogicalGroup"){
       $iLogicalGroupTerm = "";	
    }
    my $iLogicalGroupTermCookie= $query->cookie(-name=>"iLogicalGroupTerm", -value=>"$iLogicalGroupTerm");
    print "Set-Cookie:$iLogicalGroupTermCookie;\n"; 

    #-- Discover Thin Pools
    my $chDiscoverThinPools  = $query->param("chDiscoverThinPools");
    my $chDiscoverThinPoolsCookie= $query->cookie(-name=>"chDiscoverThinPools", -value=>"$chDiscoverThinPools");	
    print "Set-Cookie:$chDiscoverThinPoolsCookie;\n"; 
 
    my $chThinPoolSourceDeviceMappingCookie= $query->cookie(-name=>"chThinPoolSourceDeviceMapping", -value=>"");	
    print "Set-Cookie:$chThinPoolSourceDeviceMappingCookie;\n"; 

    if ($chDiscoverThinPools eq "DiscoverThinPools") {      
        my $iThinPoolTerm  = $query->param("iThinPoolTerm");
        my $iThinPoolTermCookie= $query->cookie(-name=>"iThinPoolTerm", -value=>"$iThinPoolTerm");	
        print "Set-Cookie:$iThinPoolTermCookie;\n"; 
        
        my $chThinPoolSourceDeviceMapping  = $query->param("chThinPoolSourceDeviceMapping");
        my $chThinPoolSourceDeviceMappingCookie= $query->cookie(-name=>"chThinPoolSourceDeviceMapping", -value=>"$chThinPoolSourceDeviceMapping");	
        print "Set-Cookie:$chThinPoolSourceDeviceMappingCookie;\n"; 
 
        my $chLogicalThingPoolCookie= $query->cookie(-name=>"chLogicalThingPool", -value=>"");	
        print "Set-Cookie:$chLogicalThingPoolCookie;\n";        
        my $chPhysicalThingPoolCookie= $query->cookie(-name=>"chPhysicalThingPool", -value=>"");	
        print "Set-Cookie:$chPhysicalThingPoolCookie;\n";

        my $chLogicalThingPool  = $query->param("chLogicalThingPool");

        my $chLogicalThingPoolCookie= $query->cookie(-name=>"chLogicalThingPool", -value=>"$chLogicalThingPool");	
        print "Set-Cookie:$chLogicalThingPoolCookie;\n"; 
        my $chPhysicalThingPool  = $query->param("chPhysicalThingPool");

        my $chPhysicalThingPoolCookie= $query->cookie(-name=>"chPhysicalThingPool", -value=>"$chPhysicalThingPool");	
        print "Set-Cookie:$chPhysicalThingPoolCookie;\n"; 
        
        my $chThinPoolLogicalDiskMappingCookie= $query->cookie(-name=>"chThinPoolLogicalDiskMapping", -value=>"");	
        print "Set-Cookie:$chThinPoolLogicalDiskMappingCookie;\n"; 
        if ($chDiscoverLogicalDisk eq "DiscoverLogicalDevices") {
           my $chThinPoolLogicalDiskMapping  = $query->param("chThinPoolLogicalDiskMapping");
           $chThinPoolLogicalDiskMappingCookie= $query->cookie(-name=>"chThinPoolLogicalDiskMapping", -value=>"$chThinPoolLogicalDiskMapping");	          
        }
        print "Set-Cookie:$chThinPoolLogicalDiskMappingCookie;\n"; 
   }
    my $commandScript =  $query->param("commandScript"); 
}

sub initializeCookieStorage(){
    my $query = new CGI();
    my @sisdkEntries =("iName", "iVersion", "iFamily", "iModel", "iDiscoveryFileName", "commandScript", "cliCommand", "iConfigureParams", "iVendor",  
               "chDiscoveryPhysicalDisk", "iPhysicalDiskTerm", "chDiscoveryPhysicalGroup", "iPhysicalGroupTerm", "chDiscoverArrayPort", 
               "chDiscoverAdapter",  "chDiscoverLogicalDisk", "iLogicalDiskTerm", "chDiscoverReplications", "chDiscoverRemoteReplication", 
               "chLogicalGroup", "iLogicalGroupTerm", "chDiscoverReplications", , "chLogicalGroup", "iLogicalGroupTerm",
               "chDiscoverLogPhyMapping", "deviceIdentifer", "chDiscoverLogHostMapping", "EncIdentiferFormula", "LogicalIdentiferFormula", "iVendorId", 
               "iProductId", "testCommandFile", "testOption", "chDiscoverRaidGroup", "iRaidGroupTerm", "chRaidGroupPhysicalMapping", "chRaidGroupLogicalDiskMapping",
               "chMetaLogicalDisk", "iTermMetaLogicalDisk", "seRemoteReplicationRadio", "chDiscoverThinPools", "iThinPoolTerm", "chThinPoolLogicalDiskMapping",
               "chThinPoolSourceDeviceMapping", "chThinPoolSourceDeviceMapping", "chLogicalThingPool", "chPhysicalThingPool");
    foreach my $entry (@sisdkEntries)
    {
        my $cookieiName = $query->cookie(-name=>"$entry", -value=> "");	
        print "Set-Cookie:$cookieiName;\n"; 
    }          
}

sub saveCliParameters ()
{    
    my $query = $_[0];
    my $configParamSet ="";
    my $commandScript = $query->param("commandScript");

    my $cliCommand = $query->param("cliCommand");
    my $cliCommandCookie= $query->cookie(-name=>"cliCommand", -value=> $cliCommand);
    print "Set-Cookie:$cliCommandCookie;\n";
    
    my $cliNames = "";
    # multiple parameters in the table

    foreach my $key ($query->param) {
         my $oneConfigParam = "";
         if ($key =~ /^nameField_(.+)+/) {
            my $numberPart = $1;        

            my $cliNameFieldKey      = join "", "cliNameField", "_",  $numberPart;
            my $defaultValueFieldKey = join "", "defaultValueField", "_",  $numberPart;
            my $dataTypeSelectKey    = join "", "dataTypeSelect", "_",  $numberPart;
            my $mandatorySelectKey   = join "", "MandatorySelect", "_",  $numberPart;
            my $testValueFieldKey    = join "", "testValueField", "_",  $numberPart;
            my $nameField            = $query->param($key);
            my $cliNameField         = $query->param($cliNameFieldKey);
            my $defaultValueField    = $query->param($defaultValueFieldKey);
            my $dataTypeSelectField  = $query->param($dataTypeSelectKey);
            my $mandatorySelectField = $query->param($mandatorySelectKey);
            my $testValueField       = ""; #$query->param($testValueFieldKey);
            $cliNames .= $cliNameField." ";
     
            if ($nameField) {  
               $oneConfigParam =  join ",,,", $nameField, $cliNameField, $defaultValueField, $dataTypeSelectField, $mandatorySelectField, $testValueField;   
                VRTS::Logger::log('debug', $nameField."<saveCliParameters>".$cliNameField."<0>".$defaultValueField."<>".$dataTypeSelectField."<>". $mandatorySelectField);
            }
        }
        if ($oneConfigParam) { 
            $configParamSet = join ":::", $configParamSet, $oneConfigParam; 
        }
    }

    my $cliNameParmCookie= $query->cookie(-name=>"cliNames", -value=> $cliNames);
    print "Set-Cookie:$cliNameParmCookie;\n";  

    VRTS::Logger::log('debug', "configParamSet = $configParamSet");

    my $configParmCookie= $query->cookie(-name=>"iConfigureParams", -value=> $configParamSet);
    print "Set-Cookie:$configParmCookie;\n";  
}

sub saveDeviceIdentifer 
{    
    my $query = $_[0];

    my $feild_defs;
    my $count = 1;
    # multiple parameters in the table
    VRTS::Logger::log('debug', "<saveDeviceIdentifer START>");

    foreach my $key ($query->param) {
        # VRTS::Logger::log('debug', "Processing key:" .$key);
         if ($key =~ /^Field_(.+)+/) {
            my $numberPart = $1;                    
            my $FieldKey        = join "", "Field", "_",  $numberPart;
            my $pageNoKey       = join "", "sePageNoSelect", "_",  $numberPart;
            my $StartByteKey    = join "", "StartByteField", "_",  $numberPart;
            my $NofByteKey      = join "", "NofByteField", "_",  $numberPart;
            my $page83IdKey      = join "", "Page83IdField", "_",  $numberPart;
            my $FieldFormatKey  = join "", "FieldFormatSelect", "_",  $numberPart;
            VRTS::Logger::log('debug', $key."<saveDeviceIdentifer 1>".$query->param($pageNoKey)."<1>".$query->param($StartByteKey)."<1>".$query->param($NofByteKey)."<page83IdKey>". $query->param($page83IdKey) . "<>" . $query->param($FieldFormatKey));
           
            my $StartByte = $query->param($StartByteKey);
            #if ($StartByte) {  
                my $fkey = "\${F".$count."}";
                VRTS::Logger::log('debug', $fkey."<saveDeviceIdentifer 2>".$query->param($pageNoKey)."<2>".$query->param($StartByteKey)."<2>".$query->param($NofByteKey)."<page83IdKey>". $query->param($page83IdKey) . "<>" . $query->param($FieldFormatKey));
                $feild_defs->{$fkey}->{'pgno'}       = strtol ($query->param($pageNoKey), 16);
                $feild_defs->{$fkey}->{'start_byte'} = $query->param($StartByteKey);
                $feild_defs->{$fkey}->{'no_bytes'}   = $query->param($NofByteKey);
                if ($query->param($page83IdKey)) {
                  $feild_defs->{$fkey}->{'pg83id_type'}= $query->param($page83IdKey);
                }else{
                  $feild_defs->{$fkey}->{'pg83id_type'}= "";
                }
                $feild_defs->{$fkey}->{'format'}     = $query->param($FieldFormatKey);

                $count++;
            #}
        }
    }
    VRTS::Logger::log('debug', "End loop in <saveDeviceIdentifer> feild_defs> " . $feild_defs);
    my $iVendorIdCookie= $query->cookie(-name=>"iVendorId", -value=> $query->param("iVendorId"));
    print "Set-Cookie:$iVendorIdCookie;\n";  
    my $iProductIdCookie= $query->cookie(-name=>"iProductId", -value=> $query->param("iProductId"));
    print "Set-Cookie:$iProductIdCookie;\n";  

    if ($feild_defs) {
        VRTS::Logger::log('debug', $feild_defs."<feild_defs has value>");
        my $buf = JSON::objToJson($feild_defs);
        my $deviceIdentiferCookie= $query->cookie(-name=>"deviceIdentifer", -value=> $buf);
        print "Set-Cookie:$deviceIdentiferCookie;\n";  
    }else{
        VRTS::Logger::log('debug', $feild_defs."<feild_defs has No value>");
        my $deviceIdentiferCookie= $query->cookie(-name=>"deviceIdentifer", -value=> "");
        print "Set-Cookie:$deviceIdentiferCookie;\n";  
    }
    my $encIdentiferFormulaCookie= $query->cookie(-name=>"EncIdentiferFormula", -value=> $query->param("EncIdentiferFormula"));
    print "Set-Cookie:$encIdentiferFormulaCookie;\n";  

    my $logicalIdentiferFormulaCookie= $query->cookie(-name=>"LogicalIdentiferFormula", -value=> $query->param("LogicalIdentiferFormula"));
    print "Set-Cookie:$logicalIdentiferFormulaCookie;\n";  
    VRTS::Logger::log('debug', "<saveDeviceIdentifer END>");

}
